/*
  ͻ
                                                                          
              36 State Finite Closed Linear Cellular Automation           
                                                                          
                             Rule File Maker                              
                                                                          
                     (c) 1991 Christopher D. Watkins                      
                                                                          
  ͼ
*/

#include "stdio.h"
#include "dos.h"
#include "alloc.h"
#include "string.h"
#include "defs.h"
#include "globals.h"
#include "mathb.h"

#define States 36
#define MaxState States-1

typedef Byte State[36];
typedef State Rulei;
typedef Rulei Rule[36];
typedef char Name[33];

Name RuleFileName;
FILE *RuleFile;
Rule far *Rules;
Word i, j, k;
int x;
Byte o;
Byte r;

void WriteRuleFile()
{
  fwrite(Rules, sizeof(Rule), 36, RuleFile);
  fclose(RuleFile);
}

void main()
{
  strcpy(RuleFileName, "RULE1D.CA");
  if((RuleFile=fopen(RuleFileName, "wb"))==NULL)
  {
    printf("can't open file.\n");
    exit(1);
  }
  Rules=farcalloc(36, sizeof(Rule));
  if(Rules==NULL)
  {
    printf("can't get the mem!\n");
    exit(1);
  }
  clrscr();
  printf("Generating Rule\n");
  InitRand(14.4166);
  for(i=0; i<=35; i++)
  {
    for(j=0; j<=35; j++)
    {
      for(k=0; k<=35; k++)
      {
	if(i==k)
	  x=RandInt(States);
	else
	{
	  r=j%2;
	  switch(r)
	  {
	    case 0: x=i;
		    break;
	    case 1: x=k;
		    break;
	  }
	}
	o=(x%States)&0xFF;
	Rules[i][j][k]=o;
      }
    }
  }
  WriteRuleFile();
  farfree(Rules);
}